﻿/********************************************************************************/
/* 	gamecore.d																	*/
/*------------------------------------------------------------------------------*/
/*	製作		D.K（あるふぁ～秘密基地）										*/
/*	製作開始	2008/05/22														*/
/*	MAIL		dk@red.interq.or.jp												*/
/*	URL			http://maglog.jp/alpha-secret-base/								*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2008/05/22	初版															*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

private import state;
private import hell2;
private import boot;
private import actor;
private import vector;
private import keypad;
private import clickable;
//private import configparser;

import config;

//private import std.math;

/********************************************************************************/

//ConfigParser configparser = null;
const static string CONFIG_PATH = "config.ini";


/* GameMain *********************************************************************/
/*	ゲーム本体の状態															*/
/********************************************************************************/

class GameMain : GameState
{
public:
	//-----------------------------------------------------------------------------
	//システム制御用
	//-----------------------------------------------------------------------------
	enum SCENE{
		INIT = 0,
		START,
		MAIN,
		CLEAR,
		END,
		PAUSE,
		RELESE,
		
		//以下ゲーム内の演出
		PLAYER_WARP,
		ENEMY_GETWAIT,
		PLAYER_MISSWAIT,

		EXIT,
	};
	

	ConfigParser savedata;			// セーブデータ

	int timer;						// 汎用タイマー
	SCENE iSceneStatus;				//画面の状態
	int stage;						// ステージ
	int stage_start_count;			// ステージ開始処理
	int stage_clear_count;			// ステージ開始処理
	int game_score = 0;				//スコア
	int hi_score = 0;				//ハイスコア
	int game_time_count = 0;		//ゲーム終了までの残り時間
	int menu_input = 0;				//敵を倒したときのWAITカウンタ

	int drive = 0;					//進んだ距離
	int power = 0;					//パワーメータ
	int speed = 0;					//スピード
	
	//エフェクト用構造体
	struct EFFECT_DATA
	{
		int exist;	//存在
		int type;	//透明度
		int timer;	//生存時間
		float pos_x;//位置
		float pos_y;//位置
		int r;	//
		int g;	//
		int b;	//
		int alpha;	//透明度
		float dir;	//方向
		float speed;//速度
		float zoom_x;	//
		float zoom_y;	//
		int type2;//追加
	};
	const int EFFECT_MAX = 128;
	EFFECT_DATA effect[EFFECT_MAX];
	
	const int ITEM_MAX = 128;
	EFFECT_DATA item[EFFECT_MAX];

	
	float rerihu_zoom;
	int rerihu_yure;
	int serihu_seq;
	int player_wait;
	int player_combo;
	
	int next_item_count;
	
	Keypad keypad;					// キーボード/ゲームパッド取得用
	//-----------------------------------------------------------------------------
	//ゲーム別に使用される特別処理用変数
	//-----------------------------------------------------------------------------

	//-----------------------------------------------------------------------------
	//	コンストラクタ
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	this()
	{
		setMsg( GameState.MSG_NONE );
		// 各種初期化
		timer = 0;

		savedata          = new ConfigParser();
		keypad = new Keypad();
		keypad.SetUseCancel( false );

		iSceneStatus = SCENE.INIT;

	}

	
	//-----------------------------------------------------------------------------
	//	シーンの初期化
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void init( )
	{
Hell_write( "Gamecoer init\n" );
		//リソースの読み込み
		Hell_loadTexture("tama","resource/image/tama.bmp" , [255,255,255]);
		Hell_loadTexture("serihu","resource/image/serihu.bmp" , [0,255,0]);
		Hell_loadTexture("bg","resource/image/bg.bmp" , [0,255,0]);

		Hell_loadTexture("menu","resource/image/menu.bmp" , [0,255,0]);
		Hell_loadTexture("effect","resource/image/effect_ball.bmp" , [0,255,0]);

		Hell_loadWAV("get",         "resource/sound/l1.wav");
		Hell_loadWAV("door",        "resource/sound/puwa.wav");
		Hell_loadWAV("damage",        "resource/sound/damage.wav");
		Hell_loadWAV("select",        "resource/sound/select.wav");
		Hell_loadWAV("destroy",        "resource/sound/destroy2.wav");
		Hell_loadWAV("msg",        "resource/sound/msg.wav");
		Hell_loadWAV("ban",        "resource/sound/door_close.wav");
		Hell_loadWAV("punch",        "resource/sound/punch.wav");

		//セーブデータ
		try
		{
			savedata.load(CONFIG_PATH);
		}
		catch(Exception e)
		{
			savedata.set("HI_SCORE",         999999);
			savedata.set("HOSHI",         1);
			savedata.write();
		}
		hi_score = savedata.getint("HI_SCORE");

		game_time_count = 60*60;		//ゲーム終了までの残り時間
		drive = 0;					//進んだ距離
		power = 0;					//進んだ距離
		
		rerihu_zoom = 10.0;
		rerihu_yure = 0;
		serihu_seq = 0;
		next_item_count = 0;
		player_wait = 0;
		player_combo = 0;

Hell_write( "Gamecoer init\n" );

		iSceneStatus = SCENE.START;
	}
	


	//-----------------------------------------------------------------------------
	//	シーンの後処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void relese( )
	{
		iSceneStatus = SCENE.EXIT;
	}
	//-----------------------------------------------------------------------------
	//	開始演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_move( )
	{
		int i;

		switch( serihu_seq )
		{
		case 0:
			rerihu_zoom -= 0.2;
			if ( rerihu_zoom < 1.0 )
			{
				rerihu_zoom = 1.0;
				rerihu_yure = 10;
				serihu_seq++;
				Hell_playWAV( "ban", 0, -1 );
			}
			break;
		case 1:
			rerihu_yure -= 1;
			if ( rerihu_yure < 0 )
			{
				rerihu_yure = 0;
				serihu_seq++;
			}
			break;
		case 2:
			stage_start_count++;
			if ( stage_start_count > ( 60 * 1 ) )
			{
				serihu_seq++;
			}
			break;
		default:
			{
				Hell_playBgm( "resource/sound/02.ogg", -1, 0 );
				iSceneStatus = SCENE.MAIN;
				stage_start_count = 0;
			}
			break;
		}
	}
	//-----------------------------------------------------------------------------
	//	ステージ開始表示処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_draw( )
	{
		int rx = Hell_randInt( 0, rerihu_yure ) - ( rerihu_yure / 2 );
		int ry = Hell_randInt( 0, rerihu_yure ) - ( rerihu_yure / 2 );
		rx *= 4;
		ry *= 4;
		Hell_drawTextureEx("serihu"
			, 320 + rx
			, 240+20 + ry
			, 0
			, 0
			, 640 , 480
			, rerihu_zoom , rerihu_zoom
			, 0 );
		
//			Hell_drawFont("READY" , 240, 200 , 4 , 255,255,255);
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_move( )
	{
		if ( stage_clear_count > ( 60 * 2 ) )
		{
			if( keypad.isPushEnter(true) )
			{
				iSceneStatus = SCENE.RELESE;
			}
		}
		else 
		{
			stage_clear_count++;
		}
		
		
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の表示
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;

		Hell_setAlpha(HELL_ALPHA_NORMAL);
//		Hell_drawFont( "HI SCORE" , 400, 10 , 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( hi_score ) , 400, 30 , 4 , 255,255,255);

		Hell_drawFont( "KARI NO OWARI" , 120, 200 , 4 , 255,255,255);

		if ( hi_score <= game_score )
		{
			Hell_drawFont( "NEW RECORD !",170, 390 , 4 , 255,255,255);
		}

		if ( stage_clear_count > ( 60 * 2 ) )
		{
			Hell_drawFont("PURESS Z OR 1 BUTTON TO EXIT" , 100, 440 , 2 , 255,255,255);
		}
		else
		{
			Hell_drawFont(" OWARI !" , 200, 420 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲームオーバー演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneEnd( )
	{
//		iSceneStatus = SCENE.MAIN;
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの動作
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void move()
	{
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			init( );
			break;
		case SCENE.START:
			//開始
			SeneStart_move( );
			break;
		case SCENE.MAIN:
			keypad.update( );	//リプレイキー入力の更新
			//メイン
			system_move( );
			item_move( );
			effect_move( );

			break;
		case SCENE.CLEAR:
			//クリア
//			effect_move( );
//			mob_move( );
			SeneClear_move( );
			break;
		case SCENE.END:
			//ゲームオーバー
			break;
		case SCENE.PAUSE:
			//一時停止
			pause_move( );
			break;
		case SCENE.RELESE:
			//後処理
			relese( );
			break;

		case SCENE.EXIT:
		default:
			//シーンの終了
			setMsg(GameState.MSG_REQ_TITLE);
			break;
		}
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void draw()
	{
		// 作画開始
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			break;
		case SCENE.START:
			//開始
			system_draw( );

			SeneStart_draw( );
			break;
		case SCENE.MAIN:
			//メイン
			system_draw( );
			item_draw( );
			effect_draw( );
			break;
		case SCENE.CLEAR:
			//クリア
			system_draw( );
			SeneClear_draw( );
			break;
		case SCENE.END:
			//ゲームーバー
			system_draw( );
			SeneEnd( );
			break;
		case SCENE.PAUSE:
			//一時停止
			system_draw( );
			pause_draw( );
			break;
		case SCENE.RELESE:
			//後処理
			break;
			
			
		case SCENE.EXIT:
		default:
			break;
		}
// for debug code start
Hell_drawFPS( 550, 10 );
//Hell_drawFont( std.string.toString( cast( int )scroll_status ), 10, 10 * 1, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )position.y ), 10, 10 * 2, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )place ), 10, 10 * 3, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )motion ), 10, 10 * 4, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )debug_disp[0] ), 10, 10 * 5, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )jump_fream_count ), 10, 10 * 6, 1 , 255,255,255 );
// for debug code end

	}
	
	// 画面サイズ取得
	int getScreenWidth(){return boot.g_width;}
	int getScreenHeight(){return boot.g_height;}
	
	string zfill(string str , int n)
	{
		for(int t=str.length;t<n;t++){
			str = "0" ~ str;
		}
		return str;
	}
	
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_move( )
	{

		player_wait--;
		if ( player_wait < 0 )
		{
			player_wait = 0;
			if(keypad.isPushLeft(true))
			{
				if ( item_delete( 0 ) == true )
				{
					Hell_playWAV( "punch", 0, -1 );
					game_score += 10 + player_combo;
					next_item_count -= 10;
					player_combo++;
				}
				else
				{
					Hell_playWAV( "msg", 0, -1 );
					player_wait = 60;
				}
			}
			if(keypad.isPushUp(true))
			{
				if ( item_delete( 1 ) == true )
				{
					Hell_playWAV( "punch", 0, -1 );
					game_score += 10 + player_combo;
					next_item_count -= 10;
					player_combo++;
				}
				else
				{
					Hell_playWAV( "msg", 0, -1 );
					player_wait = 60;
				}
			}
			if(keypad.isPushRight(true))
			{
				if ( item_delete( 2 ) == true )
				{
					Hell_playWAV( "punch", 0, -1 );
					game_score += 10 + player_combo;
					next_item_count -= 10;
					player_combo++;
				}
				else
				{
					Hell_playWAV( "msg", 0, -1 );
					player_wait = 60;
				}
			}
		}
		
		next_item_count--;
		if ( next_item_count < 0 )
		{
			next_item_count = Hell_randInt( 0, 60 );
			next_item_count += 10;
			create_item( Hell_randInt( 0, 3 ), 100, -100, 0, 8 + cast( int )( player_combo / 10) );
		}
		
		//残り時間のカウント
		game_time_count--;
		if ( game_time_count <= 0 )
		{
			game_time_count = 0;
			Hell_playBgm( "resource/sound/results.ogg", -1, 0 );

			//ハイスコアの保存
//			game_score = game_time_count;
			if ( hi_score < game_score )
			{
				keypad.save( "replay/replay_01.bin" );	//リプレイの保存
				hi_score = game_score;
				savedata.set("HI_SCORE",   cast(int)hi_score);
				savedata.write();
			}

			iSceneStatus = SCENE.CLEAR;
		}
		
		if ( iSceneStatus == SCENE.MAIN )
		{
			if(keypad.isPushCancel(true))
			{
				//ポーズ
//				iSceneStatus = SCENE.PAUSE;
//				menu_input = 0;
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;
		int r = 255;
		int g = 255;
		int b = 255;
		
		
		Hell_drawTextureEx("bg"
			, 320
			, 240
			, 0
			, 0
			, 640 , 480
			, 1 , 1
			, 0 );
		
		
		
		if ( game_time_count > 0 )
		{
			
			Hell_drawRect( 170 - 2, 150 - 2, 300 + 4, 10 + 4, 0, 0, 255, 255, 255, 255);
			Hell_drawRect( 170, 150, 300, 10, 0, 0, 0, 0, 0, 255);
			if ( player_wait > 0 )
			{
				int haba = ( player_wait * 300 ) / 60;
				Hell_drawFont( "KARI WAIT" , 170, 130 , 2 , 255,255,255);
				Hell_drawRect( 170, 150, cast( int )haba, 10, 0, 0, 0, 255, 0, 255);
			} 
			else
			{
				Hell_drawFont( "KARI OK" , 170, 130 , 2 , 255,255,255);
			}
		
			Hell_drawFont( "LEFT KEY" , 100 - 60, 460 , 2 , 255,255,255);
			Hell_drawFont( "UP KEY" , 320 - 50, 460 , 2 , 255,255,255);
			Hell_drawFont( "RIGHT KEY" , 640 - 100 - 60, 460 , 2 , 255,255,255);
		
		
			min = ( game_time_count / 60 ) / 60;
			sec = ( game_time_count / 60 ) % 60;
			msec = game_time_count % 60;
			
			str = std.string.format( "TIME %02d:%02d:%02d", min, sec, msec );
			Hell_setAlpha(HELL_ALPHA_NORMAL);
			Hell_drawFont( str , 150, 100 , 3 , r,g,b);
		}

		str = std.string.format( "SCORE %d", game_score );
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawFont( str , 30, 30 , 3 , r,g,b);

//		Hell_drawFont( "SCORE" , 10, 10 , 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( game_score ) , 10, 30 , 4 , 255,255,255);

		Hell_drawFont( "HI SCORE" , 300, 10 , 2 , 255,255,255);
		str = std.string.format( "%d", hi_score );
		Hell_drawFont( str , 300, 30 , 4 , 255,255,255);
	
	}
	
	//-----------------------------------------------------------------------------
	//	ポーズの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_move( )
	{
		if(keypad.isPushUp(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input++;
			if ( menu_input > 1 )
			{
				menu_input = 0;
			}
		}
		else if(keypad.isPushDown(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input--;
			if ( menu_input < 0 )
			{
				menu_input = 1;
			}
		}
		if(keypad.isPushEnter(true))
		{
			switch ( menu_input )
			{
			case 0:
				//ポーズ解除
				iSceneStatus = SCENE.MAIN;
				break;
			case 1:
				//リトライ
				iSceneStatus = SCENE.RELESE;
				break;
			default:
				break;
			}
		}
		if(keypad.isPushCancel(true))
		{
			//ポーズ解除
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ポーズの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_draw( )
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawTexture("menu"
			, 96 + 160
			, 64 + 120 + ( menu_input * 32 )
			, 320
			, 0
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		Hell_drawTexture("menu"
			, 160
			, 120
			, 0
			, 0
			, 320, 240
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
	}
	
	//-----------------------------------------------------------------------------
	//	エフェクトの作成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void create_effect( int type, float x, float y, float dir, float speed )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist == 0 )
			{
				effect[i].exist = 1;	//存在
				effect[i].type = type;	//
				effect[i].timer = 0;	//生存時間
				effect[i].pos_x = x;	//位置
				effect[i].pos_y = y;	//位置
				effect[i].alpha = 255;	//透明度
				effect[i].dir = dir;	//
				effect[i].speed = speed;	//
				effect[i].type2 = 0;
				
				switch( effect[i].type )
				{
				case 0:
					effect[i].r = Hell_randInt(0, 255);	//色
					effect[i].g = Hell_randInt(0, 255);	//色
					effect[i].b = Hell_randInt(0, 255);	//色
					effect[i].zoom_x = 1.0;	//拡大率
					effect[i].zoom_y = 1.0;	//拡大率
					break;
				case 1:
					effect[i].type2 = cast(int)dir;
					effect[i].dir = 180;	//
					effect[i].speed = 2;	//
					effect[i].r = 255;	//色
					effect[i].g = 255;	//色
					effect[i].b = 255;	//色
					effect[i].zoom_x = 1.0;	//拡大率
					effect[i].zoom_y = 1.0;	//拡大率
					break;
				default:
					break;
				}
				break;
			}
		}
	}
	//エフェクトの表示
	void effect_draw( )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist != 0 )
			{
				switch( effect[i].type )
				{
				case 0:
					Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
					Hell_drawTextureEx("effect"
						, effect[i].pos_x
						, effect[i].pos_y
						, 0
						, 0
						, 128, 128
						, effect[i].zoom_x , effect[i].zoom_y
						, 0
						,effect[i].r, effect[i].g, effect[i].b, effect[i].alpha );
					break;
				case 1:
				{
					int r = 255;
					int g = 255;
					int b = 255;
					if ( ( effect[i].timer % 2 ) == 0 )
					{
						r = Hell_randInt(0, 255);	//色
						g = Hell_randInt(0, 255);	//色
						b = Hell_randInt(0, 255);	//色
					}
					
					char[] str;
					str = std.string.format( "%d COMBO!", effect[i].type2 );
					Hell_setAlpha(HELL_ALPHA_NORMAL);
					Hell_drawFont( str , cast(int)effect[i].pos_x - 50, cast(int)effect[i].pos_y , 2 , r,g,b);
					break;
				}
				default:
					break;
				}
				
			}
		}
		Hell_setAlpha( HELL_ALPHA_NORMAL );			//通常半透明に戻す
	}
	//エフェクトの移動
	void effect_move( )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist != 0 )
			{
				effect[i].timer++;	//生存時間

				float vx = Hell_sin( Hell_deg2rad( effect[i].dir ) ) * effect[i].speed;
				float vy = Hell_cos( Hell_deg2rad( effect[i].dir ) ) * effect[i].speed;
				effect[i].pos_x += vx;	//位置
				effect[i].pos_y += vy;	//位置

				switch( effect[i].type )
				{
				case 0:
					effect[i].zoom_x -= 0.02;	//
					effect[i].zoom_y -= 0.02;	//
					if ( effect[i].zoom_x < 0.0 )
					{
						effect[i].zoom_x = 0.0;
					}
					if ( effect[i].zoom_y < 0.0 )
					{
						effect[i].zoom_y = 0.0;
					}

					effect[i].alpha -= 8;	//透明度
					if ( effect[i].alpha < 0 )
					{
						effect[i].exist = 0;	//消える 
					}
					break;
				case 1:
					if ( effect[i].timer > 60 )	//生存時間
					{
						effect[i].exist = 0;	//消える 
					}
					break;
				default:
					break;
				}
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	アイテムの作成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void create_item( int type, float x, float y, float dir, float speed )
	{
		int i = 0;
		for ( i = 0; i < ITEM_MAX; i++ )
		{
			if ( item[i].exist == 0 )
			{
				item[i].exist = 1;	//存在
				item[i].type = type;	//
				item[i].timer = 0;	//生存時間
				
				switch( type )
				{
				case 0:
					x = 100;
					break;
				case 1:
					x = 320;
					break;
				case 2:
					x = 640 - 100;
					break;
				default:
					break;
				}
				item[i].type2 = Hell_randInt(0, 4);
				
				item[i].pos_x = x;	//位置
				item[i].pos_y = y;	//位置
				item[i].alpha = 255;	//透明度
				item[i].dir = dir;	//
				item[i].speed = speed;	//
				
				//タイプによってパラメータを分けるといいかも
				item[i].r = 255;	//色
				item[i].g = 255;	//色
				item[i].b = 255;	//色
				item[i].zoom_x = 1.0;	//拡大率
				item[i].zoom_y = 1.0;	//拡大率
				break;
			}
		}
	}
	//エフェクトの表示
	void item_draw( )
	{
		int i = 0;
		for ( i = 0; i < ITEM_MAX; i++ )
		{
			if ( item[i].exist != 0 )
			{
				switch ( item[i].type2 )
				{
				case 0:
					Hell_drawTextureEx("tama"
						, item[i].pos_x
						, item[i].pos_y
						, 0
						, 0
						, 64, 64
						, item[i].zoom_x , item[i].zoom_y
						, 0
						,item[i].r, item[i].g, item[i].b, item[i].alpha );
					break;
				case 1:
					Hell_drawTextureEx("tama"
						, item[i].pos_x
						, item[i].pos_y
						, 64
						, 0
						, 64, 64
						, item[i].zoom_x , item[i].zoom_y
						, 0
						,item[i].r, item[i].g, item[i].b, item[i].alpha );
					break;
				case 2:
					Hell_drawTextureEx("tama"
						, item[i].pos_x
						, item[i].pos_y
						, 128
						, 0
						, 64, 64
						, item[i].zoom_x , item[i].zoom_y
						, 0
						,item[i].r, item[i].g, item[i].b, item[i].alpha );
					break;
				case 3:
					Hell_drawTextureEx("tama"
						, item[i].pos_x
						, item[i].pos_y
						, 192
						, 0
						, 64, 64
						, item[i].zoom_x , item[i].zoom_y
						, 0
						,item[i].r, item[i].g, item[i].b, item[i].alpha );
					break;
				default:
					break;
				}
//				Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
			}
		}
//		Hell_setAlpha( HELL_ALPHA_NORMAL );			//通常半透明に戻す
	}
	//エフェクトの移動
	void item_move( )
	{
		int i = 0;
		for ( i = 0; i < ITEM_MAX; i++ )
		{
			if ( item[i].exist != 0 )
			{
				item[i].timer++;	//生存時間

				float vx = Hell_sin( Hell_deg2rad( item[i].dir ) ) * item[i].speed;
				float vy = Hell_cos( Hell_deg2rad( item[i].dir ) ) * item[i].speed;
				item[i].pos_x += vx;	//位置
				item[i].pos_y += vy;	//位置
				
				if ( item[i].pos_y > 580 )
				{
					item[i].exist = false;
					player_combo = 0;
				}

			}
		}
	}

	bool item_delete( int type )
	{
		int i = 0;
		float ymax = 0;
		int ymax_index = 0;
		bool rc = false;
		for ( i = 0; i < ITEM_MAX; i++ )
		{
			if ( item[i].exist != 0 )
			{
				if ( type == item[i].type )
				{
					rc = true;
					if ( item[i].pos_y > ymax)
					{
						ymax = item[i].pos_y;
						ymax_index = i;
					}
					
				}
			}
		}
		if ( rc == true )
		{
			item[ymax_index].exist = false;
			
			int ei = 0;
			//エフェクトの作成
			if ( player_combo > 0 )
			{
				create_effect( 1, item[ymax_index].pos_x, item[ymax_index].pos_y, cast( float )player_combo, 0 );
			}
			create_effect( 0, item[ymax_index].pos_x, item[ymax_index].pos_y, 0, 0 );
			for ( ei = 0; ei < 16; ei++ )
			{
				float dir = cast( float )Hell_randInt(0, 3600) / 10.0;
				float spd = cast( float )Hell_randInt(0, 100) / 10.0;
				create_effect( 0, item[ymax_index].pos_x, item[ymax_index].pos_y, dir, spd );
			}
		}
		
		return( rc );
	}
	
}


